.setcpu "65816"
.smart

.include "Header.asm"
.include "InitializeSNES.asm"
.include "InitializeControllers.asm"

;======================================================================
.segment "ZEROPAGE"
;======================================================================

Joy1Data:		.res 2
Joy2Data:		.res 2
Joy1Press:		.res 2
Joy2Press:		.res 2
ColorCounter:		.res 2

;======================================================================
.segment "BSS7E"
;======================================================================

;======================================================================
.segment "BSS7F"
;======================================================================

;======================================================================
.segment "CODE"
;======================================================================

.proc Main
  InitializeSNES
  jsr InitializeControllers

  sep #$20	;A=8

;Enable NMI	(when interrupts get re-enabled) and joypad reading
  lda #$81
  sta $4200

;Turn on screen, full brightness
  lda #$0F
  sta $2100

  cli		; Restore interrupts -- we're all ready to go!

  rep #$30   ; A=16, X/Y=16

InfiniteLoop:
  wai
  stz $2121
  lda ColorCounter
  sta $2122
  lda ColorCounter
  sta $2122
  inc ColorCounter
  jmp InfiniteLoop
.endproc

;======================================================================

.proc VBlank
  rep #$30   ; A=16, X/Y=16
  pha
  phx
  phy
  phd
  phb
  php

  jsr GetControllerInput

  lda $4210       ; clear NMI Flag

  plp
  plb
  pld
  ply
  plx
  pla
  rti
.endproc

;======================================================================
.segment "RODATA"
;======================================================================